#[macro_export]
macro_rules! cpointer_pathbuf {
    ( $name:ident, $cstring_name:ident, $x:expr ) => {
        let $cstring_name = $x.to_str().map(CString::new).unwrap_or(CString::new(""))?;

        let $name = $cstring_name.into_raw();
    };
}

#[macro_export]
macro_rules! cpointer_string {
    ( $name:ident, $cstring_name:ident, $x:expr ) => {
        let $cstring_name = CString::new($x.clone().as_str())?;
        let $name = $cstring_name.into_raw();
    };
}

#[macro_export]
macro_rules! cpointer_stringvec {
    ( $name:ident, $vec_name:ident, $x:expr ) => {
        let mut $vec_name = $x
            .iter()
            .map(Ok)
            .map(|elem_result: Result<_>| {
                elem_result.and_then(|elem| {
                    cpointer_string!(elem_cptr, elem_cstring, elem);
                    Ok(elem_cptr)
                })
            })
            .fold(Ok(vec![]), crate::types::result_flatten)?;

        $vec_name.append(&mut vec![0 as *mut _]);
        let $name = $vec_name.as_slice().as_ptr();
    };
}
