use crate::errors::{Errno, Error};
use crate::types::Result;

use std::os::unix::io::RawFd;

use num_traits::FromPrimitive;
use syscalls::*;

pub fn close(fd: RawFd) -> Result<i64> {
    unsafe { syscall!(SYS_close, fd as i64) }.map_err(|errno| {
        Error::ProviderError(format!("close, errno: {:?}", Errno::from_i64(errno)))
    })
}
